"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerParticipant(ProtocolElement):
    """
    This defines a Cancer Participant
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "readyForAnalysis",
        "sex",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import participant as participant_1_5_0

        return {
            "consentStatus": participant_1_5_0.ConsentStatus,
            "germlineSamples": participant_1_5_0.GermlineSample,
            "previousTreatment": participant_1_5_0.PreviousTreatment,
            "testConsentStatus": participant_1_5_0.GmsConsentStatus,
            "tumourSamples": participant_1_5_0.TumourSample,
            "tumours": participant_1_5_0.Tumour,
            "versionControl": participant_1_5_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import participant as participant_1_5_0

        return {
            "sex": participant_1_5_0.Sex,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.ConsentStatus": participant_1_5_0.ConsentStatus,
            "org.gel.models.participant.avro.GermlineSample": participant_1_5_0.GermlineSample,
            "org.gel.models.participant.avro.PreviousTreatment": participant_1_5_0.PreviousTreatment,
            "org.gel.models.participant.avro.Sex": participant_1_5_0.Sex,
            "org.gel.models.participant.avro.GmsConsentStatus": participant_1_5_0.GmsConsentStatus,
            "org.gel.models.participant.avro.TumourSample": participant_1_5_0.TumourSample,
            "org.gel.models.participant.avro.Tumour": participant_1_5_0.Tumour,
            "org.gel.models.participant.avro.VersionControl": participant_1_5_0.VersionControl,
            "org.gel.models.participant.avro.CancerParticipant": participant_1_5_0.CancerParticipant,
        }

    __slots__ = [
        "readyForAnalysis",
        "sex",
        "additionalInformation",
        "assignedICD10",
        "center",
        "consentStatus",
        "germlineSamples",
        "individualId",
        "morphology",
        "participantId",
        "participantUid",
        "previousTreatment",
        "primaryDiagnosisDisease",
        "primaryDiagnosisSubDisease",
        "testConsentStatus",
        "tumourSamples",
        "tumours",
        "versionControl",
        "yearOfBirth",
    ]

    def __init__(
        self,
        readyForAnalysis,
        sex,
        additionalInformation=None,
        assignedICD10=None,
        center=None,
        consentStatus=None,
        germlineSamples=None,
        individualId=None,
        morphology=None,
        participantId=None,
        participantUid=None,
        previousTreatment=None,
        primaryDiagnosisDisease=None,
        primaryDiagnosisSubDisease=None,
        testConsentStatus=None,
        tumourSamples=None,
        tumours=None,
        versionControl=None,
        yearOfBirth=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.CancerParticipant model.

        :param readyForAnalysis:
            Flag indicating if the participant is ready for analysis         NOTE:
            In GMS, this will default to true
        :type readyForAnalysis: boolean
        :param sex:
            Sex
        :type sex: Sex
        :param additionalInformation:
            We could add a map here to store additional information for example
            URIs to images, ECGs, etc
        :type additionalInformation: None | dict[str, str]
        :param assignedICD10:
            assigned ICD10 code         IN GMS, this is deprecated
        :type assignedICD10: None | list[str]
        :param center:
            Center         NOTE: In GMS, this will be taken from the ReferralTest
            and duplicated here
        :type center: None | str
        :param consentStatus:
            What has this participant consented to?         A participant that has
            been consented to the programme should also have sequence
            data associated with them; however         this needs to
            be programmatically checked
        :type consentStatus: None | ConsentStatus
        :param germlineSamples:
            List of germline samples         IN GMS, this is deprecated and moved
            to ReferralTest
        :type germlineSamples: None | list[GermlineSample]
        :param individualId:
            Individual identifier
        :type individualId: None | str
        :param morphology:
            Morphology of any tumours         NOTE: In GMS, this field is
            deprecated as morphology will be in sample or with respect
            to a tumour record
        :type morphology: None | list[str]
        :param participantId:
            This is a human readable participant ID
        :type participantId: None | str
        :param participantUid:
            Individual UID in GMS
        :type participantUid: None | str
        :param previousTreatment:
            In GMS, any previous treatment recorded in TOMs
        :type previousTreatment: None | list[PreviousTreatment]
        :param primaryDiagnosisDisease:
            This should be an enumeration when it is well defined         blood,
            breast, prostate, colorectal, cll, aml, renal, ovarian,
            skin, lymphNode, bone, saliva //for individual - there
            could be more than I have listed here, in fact there
            definitely will.         In GMS, this field is deprecated
        :type primaryDiagnosisDisease: None | list[str]
        :param primaryDiagnosisSubDisease:
            This should be an enumeration when it is well defined         blood,
            breast, prostate, colorectal, cll, aml, renal, ovarian,
            skin, lymphNode, bone, saliva //for individual - there
            could be more than I have listed here, in fact there
            definitely will.         In GMS, this field is deprecated
        :type primaryDiagnosisSubDisease: None | list[str]
        :param testConsentStatus:
            What has this participant consented in the context of a Genomic Test?
        :type testConsentStatus: None | GmsConsentStatus
        :param tumourSamples:
            List of tumour samples         IN GMS, this is deprecated and moved to
            ReferralTest
        :type tumourSamples: None | list[TumourSample]
        :param tumours:
            In GMS, for all tumours for the CancerParticipant, independent of any
            samples
        :type tumours: None | list[Tumour]
        :param versionControl:
            Model version number
        :type versionControl: None | VersionControl
        :param yearOfBirth:
            Year of birth for the cancer participant
        :type yearOfBirth: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
